//
//	Q3Utilities.h
//
//	A bunch of handy QD3D utilites, mostly math.
//	These are written as if they were natural extensions of the QD3D API.
//
//	by James Jennings
//	March 9, 1997
//

#pragma once

class Q3 {
public:
	
	static TQ3Boolean Vector3D_Parallel( const TQ3Vector3D *v1, const TQ3Vector3D *v2 );
	
	static TQ3Boolean Vector3D_Orthogonal( const TQ3Vector3D *v1, const TQ3Vector3D *v2 );
	
	static TQ3Vector3D * Vector3D_MakeOrthogonal( 
		const TQ3Vector3D *v1, const TQ3Vector3D *v2, TQ3Vector3D *v3);
	
	static TQ3Vector3D * Vector3D_CompleteBasis( 
		const TQ3Vector3D *v1, const TQ3Vector3D *v2, TQ3Vector3D *v3);
	
	static TQ3CameraPlacement * CameraPlacement_Transform( 
		const TQ3CameraPlacement *inPlace, const TQ3Matrix4x4 *M, TQ3CameraPlacement *outPlace );

	static TQ3Boolean CameraPlacement_Validate( TQ3CameraPlacement *inPlace );
	
	static TQ3Matrix4x4 * Transform_SetRotatePlacementToPlacement( 
		TQ3Matrix4x4 *M, const TQ3CameraPlacement *in1, const TQ3CameraPlacement *in2 );

};

