//
//	CQD3DErrorWindow.h
//
//	class CQD3DErrorWindow
//	Send QuickDraw 3D errors to a TextEdit window.
//
//	I haven't had enough QD3D errors to really test this.
//
//	by James Jennings
//	November 23, 1995
//	Converted from an LSingleDoc to an LWindow, July 8, 1996
//

#pragma once

#include <LWindow.h>

class CQD3DErrorWindow : public LWindow {
public:
	enum { class_ID = 'Q3Er' };
	static CQD3DErrorWindow * CreateFromStream( LStream *inStream );
	// Note: Since Install() is only called once, it will also register the class.
	static void		Install( LCommander *inSuper );	
	
	CQD3DErrorWindow( LStream *inStream );
	
	virtual		~CQD3DErrorWindow();
	
	virtual void	FinishCreateSelf();
	
	
	static CQD3DErrorWindow *GetInstance() { return sSingleton; }
	
protected:
			void	Common(StringPtr type, long first, long last);
			void	Write( ConstStringPtr str );
	TEHandle	mTE;	// the TERecord we stuff things into
	Int32		mNumberOfErrors;
private:
	static CQD3DErrorWindow *sSingleton;
	static void ErrorMethod(  TQ3Error first,   TQ3Error last,   long reference);
	static void WarningMethod(TQ3Warning first, TQ3Warning last, long reference);
	static void NoticeMethod( TQ3Notice first,  TQ3Notice last,  long reference);
};
