//
//	QD3D Debug Macros.h
//

#pragma once

#include <UException.h>
#include <QD3DErrors.h>

enum {
	err_Q3Error		= 'Q3er',
	err_Q3Warning	= 'Q3wa',
	err_Q3Notice	= 'Q3no',
	err_Q3Failure	= 'Q3fa'	// TQ3Status result
};

//#define ThrowIfQ3Error_()	ThrowIfOSErr_(Q3Error_Get(0))
#define ThrowIfQ3Error_()	\
do {	\
	TQ3Error err = ::Q3Error_Get(0);	\
	if (err==kQ3ErrorMacintoshError) ThrowIfOSErr_(::Q3MacintoshError_Get(0));	\
	ThrowIfOSErr_(err);	\
} while (false)

#define ThrowIfQ3Warning_() ThrowIfOSErr_(::Q3Warning_Get(0))
#define ThrowIfQ3Notice_()	ThrowIfOSErr_(::Q3Notice_Get(0))
#define ThrowIfQ3Any_()		\
	do { ThrowIfQ3Error_(); ThrowIfQ3Warning_(); ThrowIfQ3Notice_(); } while (false)
	
#define	ThrowIfQ3Fail_(status)										\
	do {															\
		if ((status)==kQ3Failure) Throw_(err_Q3Failure);			\
	} while (false)
