/* QD3D Error Codes.r */

#define systemSevenOrLater 1
#include "Types.r"

// The OS Error type. The ID of each resource refers to the 
// OSErr that it describes.
type 'Estr' {	/* defined just like a 'STR ' */
	pstring;
};

/* The error strings corresponding to QD3DErrors.h */

/* ************** */
/* *** Errors *** */
/* ************** */
resource 'Estr' (-28500, purgeable) {
	"kQ3ErrorInternalError"
};
resource 'Estr' (-28500+1, purgeable) {
	"kQ3ErrorNoRecovery"
};
resource 'Estr' (-28500+2, purgeable) {
	"kQ3ErrorLastFatalError"
};
	/* System Errors */
resource 'Estr' (-28490, purgeable) {
	"kQ3ErrorNotInitialized"
};
resource 'Estr' (-28490+1, purgeable) {
	"kQ3ErrorAlreadyInitialized"
};
resource 'Estr' (-28490+2, purgeable) {
	"kQ3ErrorUnimplemented"
};
resource 'Estr' (-28490+3, purgeable) {
	"kQ3ErrorRegistrationFailed"
};
	/* OS Errors */
resource 'Estr' (-28490+4, purgeable) {
	"kQ3ErrorUnixError"
};
resource 'Estr' (-28490+5, purgeable) {
	"kQ3ErrorMacintoshError"
};
resource 'Estr' (-28490+6, purgeable) {
	"kQ3ErrorX11Error"
};
	/* Memory Errors */
resource 'Estr' (-28490+7, purgeable) {
	"kQ3ErrorMemoryLeak"
};
resource 'Estr' (-28490+8, purgeable) {
	"kQ3ErrorOutOfMemory"
};
	/* Parameter errors */
resource 'Estr' (-28490+9, purgeable) {
	"kQ3ErrorNULLParameter"
};
resource 'Estr' (-28490+10, purgeable) {
	"kQ3ErrorParameterOutOfRange"
};
resource 'Estr' (-28490+11, purgeable) {
	"kQ3ErrorInvalidParameter"
};			
resource 'Estr' (-28490+12, purgeable) {
	"kQ3ErrorInvalidData"
};				
resource 'Estr' (-28490+13, purgeable) {
	"kQ3ErrorAcceleratorAlreadySet"
};		
resource 'Estr' (-28490+14, purgeable) {
	"kQ3ErrorVector3DNotUnitLength"
};
resource 'Estr' (-28490+15, purgeable) {
	"kQ3ErrorVector3DZeroLength"
};
	/* Object Errors */
resource 'Estr' (-28490+16, purgeable) {
	"kQ3ErrorInvalidObject"
};
resource 'Estr' (-28490+17, purgeable) {
	"kQ3ErrorInvalidObjectClass"
};
resource 'Estr' (-28490+18, purgeable) {
	"kQ3ErrorInvalidObjectType"
};
resource 'Estr' (-28490+19, purgeable) {
	"kQ3ErrorInvalidObjectName"
};
resource 'Estr' (-28490+20, purgeable) {
	"kQ3ErrorObjectClassInUse"
};			
resource 'Estr' (-28490+21, purgeable) {
	"kQ3ErrorAccessRestricted"
};
resource 'Estr' (-28490+22, purgeable) {
	"kQ3ErrorMetaHandlerRequired"
};
resource 'Estr' (-28490+23, purgeable) {
	"kQ3ErrorNeedRequiredMethods"
};
resource 'Estr' (-28490+24, purgeable) {
	"kQ3ErrorNoSubClassType"
};
resource 'Estr' (-28490+25, purgeable) {
	"kQ3ErrorUnknownElementType"
};
resource 'Estr' (-28490+26, purgeable) {
	"kQ3ErrorNotSupported"
};
	/* Extension Errors */
resource 'Estr' (-28490+27, purgeable) {
	"kQ3ErrorNoExtensionsFolder"
};
resource 'Estr' (-28490+28, purgeable) {
	"kQ3ErrorExtensionError"
};
resource 'Estr' (-28490+29, purgeable) {
	"kQ3ErrorPrivateExtensionError"
};
	/* Geometry Errors */
resource 'Estr' (-28490+30, purgeable) {
	"kQ3ErrorDegenerateGeometry"
};
resource 'Estr' (-28490+31, purgeable) {
	"kQ3ErrorGeometryInsufficientNumberOfPoints"
};
	/* IO Errors */
resource 'Estr' (-28490+32, purgeable) {
	"kQ3ErrorNoStorageSetForFile"
};
resource 'Estr' (-28490+33, purgeable) {
	"kQ3ErrorEndOfFile"
};
resource 'Estr' (-28490+34, purgeable) {
	"kQ3ErrorFileCancelled"
};
resource 'Estr' (-28490+35, purgeable) {
	"kQ3ErrorInvalidMetafile"
};
 resource 'Estr' (-28490+36, purgeable) {
	"kQ3ErrorInvalidMetafilePrimitive"
};
 resource 'Estr' (-28490+37, purgeable) {
	"kQ3ErrorInvalidMetafileLabel"
};
 resource 'Estr' (-28490+38, purgeable) {
	"kQ3ErrorInvalidMetafileObject"
};
 resource 'Estr' (-28490+39, purgeable) {
	"kQ3ErrorInvalidMetafileSubObject"
};
resource 'Estr' (-28490+40, purgeable) {
	"kQ3ErrorInvalidSubObjectForObject"
};
resource 'Estr' (-28490+41, purgeable) {
	"kQ3ErrorUnresolvableReference"
};
resource 'Estr' (-28490+42, purgeable) {
	"kQ3ErrorUnknownObject"
};
resource 'Estr' (-28490+43, purgeable) {
	"kQ3ErrorStorageInUse"
};
resource 'Estr' (-28490+44, purgeable) {
	"kQ3ErrorStorageAlreadyOpen"
};
resource 'Estr' (-28490+45, purgeable) {
	"kQ3ErrorStorageNotOpen"
};
resource 'Estr' (-28490+46, purgeable) {
	"kQ3ErrorStorageIsOpen"
};
resource 'Estr' (-28490+47, purgeable) {
	"kQ3ErrorFileAlreadyOpen"
};
resource 'Estr' (-28490+48, purgeable) {
	"kQ3ErrorFileNotOpen"
};
resource 'Estr' (-28490+49, purgeable) {
	"kQ3ErrorFileIsOpen"
};
resource 'Estr' (-28490+50, purgeable) {
	"kQ3ErrorBeginWriteAlreadyCalled"
};
resource 'Estr' (-28490+51, purgeable) {
	"kQ3ErrorBeginWriteNotCalled"
};
resource 'Estr' (-28490+52, purgeable) {
	"kQ3ErrorEndWriteNotCalled"
};
resource 'Estr' (-28490+53, purgeable) {
	"kQ3ErrorReadStateInactive"
};
resource 'Estr' (-28490+54, purgeable) {
	"kQ3ErrorStateUnavailable"
};
resource 'Estr' (-28490+55, purgeable) {
	"kQ3ErrorWriteStateInactive"
};
resource 'Estr' (-28490+56, purgeable) {
	"kQ3ErrorSizeNotLongAligned"
};
resource 'Estr' (-28490+57, purgeable) {
	"kQ3ErrorFileModeRestriction"
};
resource 'Estr' (-28490+58, purgeable) {
	"kQ3ErrorInvalidHexString"
};
resource 'Estr' (-28490+59, purgeable) {
	"kQ3ErrorWroteMoreThanSize"
};
resource 'Estr' (-28490+60, purgeable) {
	"kQ3ErrorWroteLessThanSize"
};
resource 'Estr' (-28490+61, purgeable) {
	"kQ3ErrorReadLessThanSize"
};
resource 'Estr' (-28490+62, purgeable) {
	"kQ3ErrorReadMoreThanSize"
};
resource 'Estr' (-28490+63, purgeable) {
	"kQ3ErrorNoBeginGroup"
};
resource 'Estr' (-28490+64, purgeable) {
	"kQ3ErrorSizeMismatch"
};
resource 'Estr' (-28490+65, purgeable) {
	"kQ3ErrorStringExceedsMaximumLength"
};
resource 'Estr' (-28490+66, purgeable) {
	"kQ3ErrorValueExceedsMaximumSize"
};
resource 'Estr' (-28490+67, purgeable) {
	"kQ3ErrorNonUniqueLabel"
};
resource 'Estr' (-28490+68, purgeable) {
	"kQ3ErrorEndOfContainer"
};
resource 'Estr' (-28490+69, purgeable) {
	"kQ3ErrorUnmatchedEndGroup"
};
resource 'Estr' (-28490+70, purgeable) {
	"kQ3ErrorFileVersionExists"
};
	/* View errors */
resource 'Estr' (-28490+71, purgeable) {
	"kQ3ErrorViewNotStarted"
};
resource 'Estr' (-28490+72, purgeable) {
	"kQ3ErrorViewIsStarted"
};
resource 'Estr' (-28490+73, purgeable) {
	"kQ3ErrorRendererNotSet"
};
resource 'Estr' (-28490+74, purgeable) {
	"kQ3ErrorRenderingIsActive"
};
resource 'Estr' (-28490+75, purgeable) {
	"kQ3ErrorImmediateModeUnderflow"
};
resource 'Estr' (-28490+76, purgeable) {
	"kQ3ErrorDisplayNotSet"
};
resource 'Estr' (-28490+77, purgeable) {
	"kQ3ErrorCameraNotSet"
};
resource 'Estr' (-28490+78, purgeable) {
	"kQ3ErrorDrawContextNotSet"
};
resource 'Estr' (-28490+79, purgeable) {
	"kQ3ErrorNonInvertibleMatrix"
};
resource 'Estr' (-28490+80, purgeable) {
	"kQ3ErrorRenderingNotStarted"
};
resource 'Estr' (-28490+81, purgeable) {
	"kQ3ErrorPickingNotStarted"
};
resource 'Estr' (-28490+82, purgeable) {
	"kQ3ErrorBoundsNotStarted"
};
resource 'Estr' (-28490+83, purgeable) {
	"kQ3ErrorDataNotAvailable"
};
resource 'Estr' (-28490+84, purgeable) {
	"kQ3ErrorNothingToPop"
};
	/* Renderer Errors */
resource 'Estr' (-28490+85, purgeable) {
	"kQ3ErrorUnknownStudioType"
};			
resource 'Estr' (-28490+86, purgeable) {
	"kQ3ErrorAlreadyRendering"
};
resource 'Estr' (-28490+87, purgeable) {
	"kQ3ErrorStartGroupRange"
};
resource 'Estr' (-28490+88, purgeable) {
	"kQ3ErrorUnsupportedGeometryType"
};
resource 'Estr' (-28490+89, purgeable) {
	"kQ3ErrorInvalidGeometryType"
};
resource 'Estr' (-28490+90, purgeable) {
	"kQ3ErrorUnsupportedFunctionality"
};
	/* Group Errors */
resource 'Estr' (-28490+91, purgeable) {
	"kQ3ErrorInvalidPositionForGroup"
};
resource 'Estr' (-28490+92, purgeable) {
	"kQ3ErrorInvalidObjectForGroup"
};
resource 'Estr' (-28490+93, purgeable) {
	"kQ3ErrorInvalidObjectForPosition"
};
	/* Transform Errors */
resource 'Estr' (-28490+94, purgeable) {
	"kQ3ErrorScaleOfZero"
};				
	/* String Errors */
resource 'Estr' (-28490+95, purgeable) {
	"kQ3ErrorBadStringType"
};				
	/* Attribute Errors */
resource 'Estr' (-28490+96, purgeable) {
	"kQ3ErrorAttributeNotContained"
};		
resource 'Estr' (-28490+97, purgeable) {
	"kQ3ErrorAttributeInvalidType"
};		
	/* Camera Errors */
resource 'Estr' (-28490+98, purgeable) {
	"kQ3ErrorInvalidCameraValues"
};		
	/* DrawContext Errors */
resource 'Estr' (-28490+99, purgeable) {
	"kQ3ErrorBadDrawContextType"
};
resource 'Estr' (-28490+100, purgeable) {
	"kQ3ErrorBadDrawContextFlag"
};
resource 'Estr' (-28490+101, purgeable) {
	"kQ3ErrorBadDrawContext"
};
resource 'Estr' (-28490+102, purgeable) {
	"kQ3ErrorUnsupportedPixelDepth"
};

/* **************** */
/* *** Warnings *** */
/* **************** */
	/* General System */
resource 'Estr' (-28300, purgeable) {
	"kQ3WarningInternalException"
};	
	/* Object Warnings */
resource 'Estr' (-28300+1, purgeable) {
	"kQ3WarningNoObjectSupportForDuplicateMethod"
};
resource 'Estr' (-28300+2, purgeable) {
	"kQ3WarningNoObjectSupportForDrawMethod"
};
resource 'Estr' (-28300+3, purgeable) {
	"kQ3WarningNoObjectSupportForWriteMethod"
};
resource 'Estr' (-28300+4, purgeable) {
	"kQ3WarningNoObjectSupportForReadMethod"
};
resource 'Estr' (-28300+5, purgeable) {
	"kQ3WarningUnknownElementType"
};
resource 'Estr' (-28300+6, purgeable) {
	"kQ3WarningTypeAndMethodAlreadyDefined"
};
resource 'Estr' (-28300+7, purgeable) {
	"kQ3WarningTypeIsOutOfRange"
};
resource 'Estr' (-28300+8, purgeable) {
	"kQ3WarningTypeHasNotBeenRegistered"
};
	/* Parameter Warnings */
resource 'Estr' (-28300+9, purgeable) {
	"kQ3WarningVector3DNotUnitLength"
};
	/* IO Warnings */
resource 'Estr' (-28300+10, purgeable) {
	"kQ3WarningInvalidSubObjectForObject"
};
resource 'Estr' (-28300+11, purgeable) {
	"kQ3WarningInvalidHexString"
};
resource 'Estr' (-28300+12, purgeable) {
	"kQ3WarningUnknownObject"
};
resource 'Estr' (-28300+13, purgeable) {
	"kQ3WarningInvalidMetafileObject"
};
resource 'Estr' (-28300+14, purgeable) {
	"kQ3WarningUnmatchedBeginGroup"
};
resource 'Estr' (-28300+15, purgeable) {
	"kQ3WarningUnmatchedEndGroup"
};
resource 'Estr' (-28300+16, purgeable) {
	"kQ3WarningInvalidTableOfContents"
};
resource 'Estr' (-28300+17, purgeable) {
	"kQ3WarningUnresolvableReference"
};
resource 'Estr' (-28300+18, purgeable) {
	"kQ3WarningNoAttachMethod"
};
resource 'Estr' (-28300+19, purgeable) {
	"kQ3WarningInconsistentData"
};
resource 'Estr' (-28300+20, purgeable) {
	"kQ3WarningReadLessThanSize"
};
resource 'Estr' (-28300+21, purgeable) {
	"kQ3WarningFilePointerResolutionFailed"
};
resource 'Estr' (-28300+22, purgeable) {
	"kQ3WarningFilePointerRedefined"
};
resource 'Estr' (-28300+23, purgeable) {
	"kQ3WarningStringExceedsMaximumLength"
};
	/* Memory Warnings */
resource 'Estr' (-28300+24, purgeable) {
	"kQ3WarningLowMemory"
};
resource 'Estr' (-28300+25, purgeable) {
	"kQ3WarningPossibleMemoryLeak"
};
	/* View Warnings */
resource 'Estr' (-28300+26, purgeable) {
	"kQ3WarningViewTraversalInProgress"
};
resource 'Estr' (-28300+27, purgeable) {
	"kQ3WarningNonInvertibleMatrix"
};
	/* Quaternion Warning */
resource 'Estr' (-28300+28, purgeable) {
	"kQ3WarningQuaternionEntriesAreZero"
};
	/* Renderer Warning */
resource 'Estr' (-28300+29, purgeable) {
	"kQ3WarningFunctionalityNotSupported"
};
	/* DrawContext Warning */
resource 'Estr' (-28300+30, purgeable) {
	"kQ3WarningInvalidPaneDimensions"
};
	/* Pick Warning */
resource 'Estr' (-28300+31, purgeable) {
	"kQ3WarningPickParamOutside"
};
	/* Scale Warnings */
resource 'Estr' (-28300+32, purgeable) {
	"kQ3WarningScaleEntriesAllZero"
};
resource 'Estr' (-28300+33, purgeable) {
	"kQ3WarningScaleContainsNegativeEntries"
};
	/* Generic Warnings */
resource 'Estr' (-28300+34, purgeable) {
	"kQ3WarningParameterOutOfRange"
};

resource 'Estr' (-28100, purgeable) {
	"kQ3NoticeDataAlreadyEmpty"
};

/* *************** */
/* *** Notices *** */
/* *************** */
	/* General */
resource 'Estr' (-28100+1, purgeable) {
	"kQ3NoticeMethodNotSupported"
};
resource 'Estr' (-28100+2, purgeable) {
	"kQ3NoticeObjectAlreadySet"
};
resource 'Estr' (-28100+3, purgeable) {
	"kQ3NoticeParameterOutOfRange"
};
	/* IO Notices */
resource 'Estr' (-28100+4, purgeable) {
	"kQ3NoticeFileAliasWasChanged"
};
	/* Geometry */
resource 'Estr' (-28100+5, purgeable) {
	"kQ3NoticeMeshVertexHasNoComponent"
};
resource 'Estr' (-28100+6, purgeable) {
	"kQ3NoticeMeshInvalidVertexFacePair"
};
resource 'Estr' (-28100+7, purgeable) {
	"kQ3NoticeMeshEdgeVertexDoNotCorrespond"
};
resource 'Estr' (-28100+8, purgeable) {
	"kQ3NoticeMeshEdgeIsNotBoundary"
};
	/* Draw Context */
resource 'Estr' (-28100+9, purgeable) {
	"kQ3NoticeDrawContextNotSetUsingInternalDefaults"
};
	/* Lights */
resource 'Estr' (-28100+10, purgeable) {
	"kQ3NoticeInvalidAttenuationTypeUsingInternalDefaults"
};
resource 'Estr' (-28100+11, purgeable) {
	"kQ3NoticeBrightnessGreaterThanOne"
};
	/*  Scale  */
resource 'Estr' (-28100+12, purgeable) {
	"kQ3NoticeScaleContainsZeroEntries"
};
