//
//	CCameraMaker.h
//
//	class CCameraMaker
//	A class that constructs a QuickDraw 3D View Angle Aspect camera.
//
//	It's designed to make it easy to change the camera placement
//	before you call Get() (or Make()) the first time.
//
//	by James Jennings
//	November 26, 1995
//

#pragma once

#include "CObjectMaker.h"

class CCameraMaker : public CObjectMaker<TQ3CameraObject> {
public:
	CCameraMaker(const SDimension16 &frameSize);
	virtual void	Make();
	
	// accessors
	virtual void	SetLocation(TQ3Point3D &from);
	virtual void	SetLocation(float x, float y, float z);
	virtual void	SetPointOfInterest(TQ3Point3D &to);
	virtual void	SetPointOfInterest(float x, float y, float z);
	virtual void	SetUpVector(TQ3Vector3D &up, Boolean orthogonalize = true);
	virtual void	SetUpVector(float x, float y, float z, Boolean orthogonalize = true);
	virtual void	Orthogonalize();
protected:
	TQ3ViewAngleAspectCameraData	mData;
};
