//
//	CFlyThroughDoc.h
//
//	A document class for opening a 3DMF file for viewing.
//
//	by James Jennings
//	Started February 28, 1997
//

#pragma once

#include "CVehicleViewPane.h"

// HAS_NEW_SCENE_MENU enables the code that builds some predefined scenes.
// I want to turn this off in version 1.1b2.
//#define HAS_NEW_SCENE_MENU

#ifdef HAS_NEW_SCENE_MENU
const CommandT	cmd_8Cubes  = 1001;
const CommandT	cmd_27Cubes = 1002;
const CommandT	cmd_64Cubes = 1003;
const CommandT	cmd_Scatter20Box = 1004;
const CommandT	cmd_Scatter40Box = 1007;
const CommandT	cmd_TriGridBox10 = 1005;
const CommandT	cmd_TriGridBox30 = 1006;
#endif

class CFlyThroughDoc : public LSingleDoc {
public:
	CFlyThroughDoc(LCommander *inSuper, FSSpec *inFSSpec);
#ifdef HAS_NEW_SCENE_MENU
	CFlyThroughDoc(LCommander *inSuper, CommandT inCommand);
#endif
	
	virtual void	DoAESave( FSSpec &inFileSpec, OSType inFileType );
private:
	CVehicleViewPane *	MakeWindow();
};
